using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Management;


namespace WindowsApplication1
{

    public struct SMARTAttribute
    {
        public int status;
        public int value;
        public int rawvalue;
    }
    public struct SMART
    {
        public SMARTAttribute RawReadErrorRate;
        public SMARTAttribute ReallocatedSectorCount;
        public SMARTAttribute ReallocationEventCount;
        public SMARTAttribute CurrentPendingSectorCount;
        public SMARTAttribute OfflineScanUncorrectableSectorCount;
    }


    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            ManagementObjectSearcher WMISearch = new ManagementObjectSearcher(
              "Select * from Win32_DiskDrive");
            ManagementObjectCollection Drives = WMISearch.Get();
            richTextBox1.Text = "Drive\t\t\tStatus\n";
            foreach (ManagementObject Drive in Drives)
            {
                richTextBox1.Text = richTextBox1.Text + Drive.Properties["DeviceId"].Value.ToString() + "\t";
                richTextBox1.Text = richTextBox1.Text + Drive.Properties["Status"].Value.ToString() + "\n";
            }

            WMISearch.Scope = new ManagementScope(@"\root\wmi");
           WMISearch.Query = new ObjectQuery("Select * from MSStorageDriver_FailurePredictData");

         //   WMISearch.Query = new ObjectQuery("Select * from MSStorageDriver_ATAPISmartData");
            

            ManagementObjectCollection FailDataSet = WMISearch.Get();
            
            richTextBox2.Text = "Unknw\tUnknw\tAttribute\tStatus\tUnknw\tValue\tWorst\tRaw\t\tUnknw\n";
            foreach (ManagementObject FailData in FailDataSet)
            {
                Byte[] data = (Byte[])FailData.Properties["VendorSpecific"].Value;
                for (int i = 0; i < data[0] - 1; i++)
                {
                    for (int j = 0; j < 12; j++)
                    {
                        richTextBox2.Text = richTextBox2.Text + data[i * 12 + j] + "\t";
                    }
                    richTextBox2.Text = richTextBox2.Text + "\n";
                }

                SMART smartdata;
                foreach (ManagementObject FailData2 in FailDataSet)
                {

                    Byte[] data2 = (Byte[])FailData2.Properties["VendorSpecific"].Value;

                    for (int i = 0; i < data2[0] - 1; i++)
                    {
                        int start = i * 12;
                        switch (data2[start + 2])
                        {
                            case 1:
                                smartdata.RawReadErrorRate.value = data2[start + 5];
                                smartdata.RawReadErrorRate.rawvalue = data2[start + 7] + 256 * data2[start + 8];
                                break;
                            case 5:
                                smartdata.ReallocatedSectorCount.value = data2[start + 5];
                                smartdata.ReallocatedSectorCount.rawvalue = data2[start + 7] + 256 * data2[start + 8];
                                break;
                            case 196:
                                smartdata.ReallocationEventCount.value = data2[start + 5];
                                smartdata.ReallocationEventCount.rawvalue = data2[start + 7] + 256 * data2[start + 8];
                                break;
                            case 197:
                                smartdata.CurrentPendingSectorCount.value = data2[start + 5];
                                smartdata.CurrentPendingSectorCount.rawvalue = data2[start + 7] + 256 * data2[start + 8];
                                break;
                            case 198:
                                smartdata.OfflineScanUncorrectableSectorCount.value = data2[start + 5];
                                smartdata.OfflineScanUncorrectableSectorCount.rawvalue = data2[start + 7] + 256 * data2[start + 8];
                                break;
                        }

                    }
                }



            }
        }

    }

}